'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registerElement = exports.endingTags = undefined;

var _Body = require('./components/Body');

var _Body2 = _interopRequireDefault(_Body);

var _Button = require('./components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Column = require('./components/Column');

var _Column2 = _interopRequireDefault(_Column);

var _Divider = require('./components/Divider');

var _Divider2 = _interopRequireDefault(_Divider);

var _Html = require('./components/Html');

var _Html2 = _interopRequireDefault(_Html);

var _Image = require('./components/Image');

var _Image2 = _interopRequireDefault(_Image);

var _Invoice = require('./components/Invoice');

var _Invoice2 = _interopRequireDefault(_Invoice);

var _Item = require('./components/Invoice/Item');

var _Item2 = _interopRequireDefault(_Item);

var _List = require('./components/List');

var _List2 = _interopRequireDefault(_List);

var _Location = require('./components/Location');

var _Location2 = _interopRequireDefault(_Location);

var _Raw = require('./components/Raw');

var _Raw2 = _interopRequireDefault(_Raw);

var _Section = require('./components/Section');

var _Section2 = _interopRequireDefault(_Section);

var _Social = require('./components/Social');

var _Social2 = _interopRequireDefault(_Social);

var _Table = require('./components/Table');

var _Table2 = _interopRequireDefault(_Table);

var _Text = require('./components/Text');

var _Text2 = _interopRequireDefault(_Text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MJMLStandardElements = {
  'body': _Body2.default,
  'button': _Button2.default,
  'column': _Column2.default,
  'divider': _Divider2.default,
  'html': _Html2.default,
  'image': _Image2.default,
  'invoice-item': _Item2.default,
  'invoice': _Invoice2.default,
  'list': _List2.default,
  'location': _Location2.default,
  'raw': _Raw2.default,
  'section': _Section2.default,
  'social': _Social2.default,
  'table': _Table2.default,
  'text': _Text2.default
};

var endingTags = exports.endingTags = ['mj-text', 'mj-html', 'mj-button', 'mj-list', 'mj-raw', 'mj-table', 'mj-invoice-item', 'mj-location'];

var registerElement = exports.registerElement = function registerElement(tagName, element) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  MJMLStandardElements[tagName] = element;

  if (options.endingTag) {
    endingTags.push('mj-' + tagName);
  }

  return true;
};

exports.default = MJMLStandardElements;
//# sourceMappingURL=MJMLElementsCollection.js.map
